//
//  ViewController.m
//  IGGaugeMixRangeColors
//
//  Created by IGUser on 05/08/2014.
//  Copyright (c) 2014 MyAcademy. All rights reserved.
//

#import "ViewController.h"

@interface ViewController ()

@end

@implementation ViewController

- (void)viewDidLoad
{
    [super viewDidLoad];
    gaugeView = [[IGGaugeView alloc] init];
    gaugeView.frame = CGRectMake(0, 0, self.view.frame.size.width, self.view.frame.size.height);
    gaugeView.autoresizingMask = UIViewAutoresizingFlexibleHeight|UIViewAutoresizingFlexibleWidth;
    IGBrush *whiteBrush =[[IGBrush alloc] initWithColor:[UIColor whiteColor]];
    gaugeView.backingBrush =whiteBrush;
    gaugeView.backingOutline = whiteBrush;

    
    [self addRanges];
    [self.view addSubview:gaugeView];
    
}

-(void) addRanges
{
    IGGaugeRange *range1 = [[IGGaugeRange alloc] init];
    IGBrush *brush1 = [[IGBrush alloc] initWithColor:[UIColor blueColor]];
    
    range1.brush = brush1;
    
    range1.startValue = 30;
    range1.endValue = 80;
    range1.outerStartExtent = 0.45;
    range1.outerEndExtent = 0.45;
    
    IGGaugeRange *range2 = [[IGGaugeRange alloc] init];
    
    IGBrush *brush2 = [[IGBrush alloc] initWithColor:[UIColor redColor]];

    range2.brush = brush2;
    
    range2.startValue =60;
    range2.endValue = 100;
    range2.outerStartExtent = 0.45;
    range2.outerEndExtent = 0.45;
    
    IGGaugeRange *range3 = [[IGGaugeRange alloc] init];
    
    IGBrush *brush3 = [[IGBrush alloc] initWithColor:[UIColor greenColor]];
    
    range3.brush = brush3;
    
    range3.startValue = 10;
    range3.endValue = 40;
    range3.outerStartExtent = 0.45;
    range3.outerEndExtent = 0.45;
    
    
    [self addRange:range3];
    [self addRange:range1];
    [self addRange:range2];
    
}

-(bool)checkIfRanage:(IGGaugeRange *)range1 intersectsWith:(IGGaugeRange*)range2
{
    return range1.endValue > range2.startValue && range1.startValue < range2.endValue;
}
-(bool)checkIfRanage:(IGGaugeRange *)range1 haveTheSameExtentAs:(IGGaugeRange*)range2
{
    return range1.innerStartExtent == range2.innerStartExtent && range1.innerEndExtent == range2.innerEndExtent && range1.outerStartExtent == range2.outerStartExtent && range1.outerEndExtent == range2.outerEndExtent;
}

-(void)addRange:(IGGaugeRange *)range
{
    NSArray *ranges = gaugeView.ranges;
    
    for (int i =0; i<ranges.count; i++) {
        IGGaugeRange *currentRange = ranges[i];
        bool rangesIntersect = [self checkIfRanage:range intersectsWith:currentRange];
        bool rangesHaveSameExtent = [self checkIfRanage:range intersectsWith:currentRange];
        if(rangesIntersect && rangesHaveSameExtent)
        {
            float startIntesection;
            float endintersection;
            UIColor *startColor;
            UIColor *endColor;
            if(currentRange.endValue > range.endValue)
            {
                startIntesection = currentRange.startValue;
                endintersection = range.endValue;
                currentRange.startValue = endintersection;
                range.endValue = startIntesection;
                startColor = [range.brush getUIColor];
                endColor =[currentRange.brush getUIColor];
                
            }
            else
            {
                startIntesection = range.startValue;
                endintersection = currentRange.endValue;
                range.startValue = endintersection;
                currentRange.endValue = startIntesection;
                startColor =[currentRange.brush getUIColor];
                endColor = [range.brush getUIColor];
            }
            //check if the range is drawn upside down
            //if it is reverse the colors
            if((startIntesection + endintersection) /2 > (gaugeView.minimumValue + gaugeView.maximumValue)/2)
            {
                UIColor *tempColor = startColor;
                startColor = endColor;
                endColor = tempColor;
                
            }
            
            IGGaugeRange *newRange = [[IGGaugeRange alloc] init];
            IGGradientBrush *br = [[IGGradientBrush alloc] initWithColor:startColor];
            [br addColorStopWithOffset:0.8 brush:[[IGBrush alloc] initWithColor:endColor]];
            newRange.brush  =br;
            newRange.startValue = startIntesection;
            newRange.endValue= endintersection;
            newRange.outerStartExtent = range.outerStartExtent;
            newRange.outerEndExtent = range.outerEndExtent;
            
            [gaugeView addRange:newRange];
            
        }
        
    }
    [gaugeView addRange:range];
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

@end
